/*-------------------------------------------------------------
 *  Copyright (c) 2011-2014, MSS ComBlock. All rights reserved.
 *
 * 	Filename: RF.h
 *  Last modified: 4/15/14
 *  Authors:
 *  	Alain Zarembowitch / MSS ComBlock
 *  Version: 1.0
 *  Inheritance: N/A
 *  Description: RF components driver
 -------------------------------------------------------------*/
#ifndef RF_H_
#define RF_H_


/*-------- change this section according to the schematics ----------------------------------------*/
#define PIN_SYNTH1_CLK_H() FIO1SET = 0x00000001;    // port1[0]
#define PIN_SYNTH1_DATA_H() FIO1SET = 0x00000002;	// port1[1]
#define PIN_SYNTH1_LE_H() FIO1SET = 0x00000010;    	// port1[4]
#define PIN_SYNTH1_ENABLE_H() FIO1SET = 0x00000200; // port1[9]

#define PIN_SYNTH1_CLK_L() FIO1CLR = 0x00000001;    // port1[0]
#define PIN_SYNTH1_DATA_L() FIO1CLR = 0x00000002;	// port1[1]
#define PIN_SYNTH1_LE_L() FIO1CLR = 0x00000010;    	// port1[4]
#define PIN_SYNTH1_ENABLE_L() FIO1CLR = 0x00000200;  // port1[9]

#define PIN_SYNTH2_CLK_H() FIO1SET = 0x00000400;    // port1[10]
#define PIN_SYNTH2_DATA_H() FIO1SET = 0x00004000;	// port1[14]
#define PIN_SYNTH2_LE_H() FIO1SET = 0x00008000;    	// port1[15]
#define PIN_SYNTH2_ENABLE_H() FIO1SET = 0x00080000; // port1[19]

#define PIN_SYNTH2_CLK_L() FIO1CLR = 0x00000400;    // port1[10]
#define PIN_SYNTH2_DATA_L() FIO1CLR = 0x00004000;	// port1[14]
#define PIN_SYNTH2_LE_L() FIO1CLR = 0x00008000;    	// port1[15]
#define PIN_SYNTH2_ENABLE_L() FIO1CLR = 0x00080000; // port0[19]

#define PIN_AD7298_SCLK_H() FIO2SET = 0x00000040;    // port2[6]
#define PIN_AD7298_CSB_H() FIO2SET = 0x00000100;    // port2[8]
#define PIN_AD7298_DIN_H() FIO0SET = 0x00000001;    // port0[0]

#define PIN_AD7298_SCLK_L() FIO2CLR = 0x00000040;    // port2[6]
#define PIN_AD7298_CSB_L() FIO2CLR = 0x00000100;    // port2[8]
#define PIN_AD7298_DIN_L() FIO0CLR = 0x00000001;    // port0[0]

#define PIN_AD5621_1_SDIN_H() FIO2SET = 0x00000001;    // port2[0]
#define PIN_AD5621_1_SCLK_H() FIO2SET = 0x00000002;    // port2[1]
#define PIN_AD5621_1_SYNCB_H() FIO2SET = 0x00000004;    // port2[2]

#define PIN_AD5621_1_SDIN_L() FIO2CLR = 0x00000001;    // port2[0]
#define PIN_AD5621_1_SCLK_L() FIO2CLR = 0x00000002;    // port2[1]
#define PIN_AD5621_1_SYNCB_L() FIO2CLR = 0x00000004;    // port2[2]

#define PIN_AD5621_2_SDIN_H() FIO2SET = 0x00000008;    // port2[3]
#define PIN_AD5621_2_SCLK_H() FIO2SET = 0x00000010;    // port2[4]
#define PIN_AD5621_2_SYNCB_H() FIO2SET = 0x00000020;    // port2[5]

#define PIN_AD5621_2_SDIN_L() FIO2CLR = 0x00000008;    // port2[3]
#define PIN_AD5621_2_SCLK_L() FIO2CLR = 0x00000010;    // port2[4]
#define PIN_AD5621_2_SYNCB_L() FIO2CLR = 0x00000020;    // port2[5]

#define PIN_RFOUT_ENB_H() FIO1SET = 0x02000000; // port1[25]
#define PIN_RFOUT_ENB_L() FIO1CLR = 0x02000000; // port1[25]

/*-------- end of schematics-dependent code ----------------------------------------*/
extern long synth_check_lock(int);
extern unsigned long get_freq(long );
extern void adf4351_reg(long, int);
extern void init_tuner_pll(int, char);
extern void program_tuner_pll(int, char);
extern void RX_TXN_R_ISR(void);
extern void RX_TXN_F_ISR(void);
extern void RX_TXN_poll(void);
extern void TX_EN_poll(void);
extern void setLNAgain(void);
extern void setRFGain(void);
extern void setIFGain(void);
extern void DAC_init(void);
extern void DAC(long);
extern void PWM_init(void);
extern void PWM(long);
extern void setTxGain(void);
extern void tx_gain_poll(void);
extern void LNA_AGC_poll(void);
extern void RF_AGC_poll(void);
extern void IF_AGC_poll(void);
extern void RF_gain_increment(void);
extern void RF_gain_decrement(void);
//extern long pinDiodeAttenuatorCompensation(long);
extern void ADC_init(void);
extern void setLPF(void);
extern int AD7298_rw(int);
extern void AD7298_poll(void);
extern void AD5621_1(int);
extern void AD5621_2(int);

#endif /* RF_H_ */
